Sizes (JGoodies Forms 1.9 API)
Date: 2015-02-02

com.jgoodies.forms.layout

## Class Sizes

- java.lang.Object
- - com.jgoodies.forms.layout.Sizes

-     public final class Sizes
      extends Object

  Consists only of static methods that create and convert sizes as required by the FormLayout. The conversion of sizes that are not based on pixel is delegated to an implementation of `UnitConverter`. The conversion methods require the layout container as parameter to read its current font and resolution.
  Version:
    $Revision: 1.19 $
  Author:
    Karsten Lentzsch
  See Also:
    `Size`, `UnitConverter`, `DefaultUnitConverter`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static com.jgoodies.forms.layout.Sizes.ComponentSize` | `DEFAULT` Use the maximum of all component sizes as column or row size; measures preferred sizes when asked for the preferred size and minimum sizes when asked for the minimum size.
    `static ConstantSize` | `DLUX1`
    `static ConstantSize` | `DLUX11`
    `static ConstantSize` | `DLUX14`
    `static ConstantSize` | `DLUX2`
    `static ConstantSize` | `DLUX21` 21 horizontal dialog units.
    `static ConstantSize` | `DLUX3`
    `static ConstantSize` | `DLUX4`
    `static ConstantSize` | `DLUX5`
    `static ConstantSize` | `DLUX6`
    `static ConstantSize` | `DLUX7`
    `static ConstantSize` | `DLUX8`
    `static ConstantSize` | `DLUX9`
    `static ConstantSize` | `DLUY1`
    `static ConstantSize` | `DLUY11`
    `static ConstantSize` | `DLUY14`
    `static ConstantSize` | `DLUY2`
    `static ConstantSize` | `DLUY21` 21 vertical dialog units.
    `static ConstantSize` | `DLUY3`
    `static ConstantSize` | `DLUY4`
    `static ConstantSize` | `DLUY5`
    `static ConstantSize` | `DLUY6`
    `static ConstantSize` | `DLUY7`
    `static ConstantSize` | `DLUY8`
    `static ConstantSize` | `DLUY9`
    `static com.jgoodies.forms.layout.Sizes.ComponentSize` | `MINIMUM` Use the maximum of all component minimum sizes as column or row size.
    `static com.jgoodies.forms.layout.Sizes.ComponentSize` | `PREFERRED` Use the maximum of all component preferred sizes as column or row size.
    `static ConstantSize` | `ZERO`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Size` | `bounded(Size basis, Size lowerBound, Size upperBound)` Creates and returns a BoundedSize for the given basis using the specified lower and upper bounds.
    `static int` | `centimeterAsPixel(double cm, Component component)` Converts Centimeters and returns pixels using the resolution of the given component's graphics object.
    `static ConstantSize` | `constant(String encodedValueAndUnit, boolean horizontal)` Creates and returns an instance of `ConstantSize` from the given encoded size and unit description.
    `static int` | `dialogUnitXAsPixel(int dluX, Component component)` Converts horizontal dialog units and returns pixels.
    `static int` | `dialogUnitYAsPixel(int dluY, Component component)` Converts vertical dialog units and returns pixels.
    `static ConstantSize` | `dluX(int value)` Creates and returns a ConstantSize for the specified value in horizontal dialog units.
    `static ConstantSize` | `dluY(int value)` Creates and returns a ConstantSize for the specified value in vertical dialog units.
    `static ConstantSize.Unit` | `getDefaultUnit()` Returns the Unit that is used if an encoded ConstantSize contains no unit string.
    `static UnitConverter` | `getUnitConverter()` Returns the current `UnitConverter`.
    `static int` | `inchAsPixel(double in, Component component)` Converts Inches and returns pixels using the specified resolution.
    `static int` | `millimeterAsPixel(double mm, Component component)` Converts Millimeters and returns pixels using the resolution of the given component's graphics object.
    `static ConstantSize` | `pixel(int value)` Creates and returns a ConstantSize for the specified pixel value.
    `static int` | `pointAsPixel(int pt, Component component)` Converts DTP Points and returns pixels using the resolution of the given component's graphics object.
    `static void` | `setDefaultUnit(ConstantSize.Unit unit)` Sets the Unit that shall be used if an encoded ConstantSize provides no unit string.
    `static void` | `setUnitConverter(UnitConverter newUnitConverter)` Sets a new UnitConverter that will be used to convert font-dependent sizes to pixel sizes.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ZERO

          public static final ConstantSize ZERO

    - #### DLUX1

          public static final ConstantSize DLUX1

    - #### DLUX2

          public static final ConstantSize DLUX2

    - #### DLUX3

          public static final ConstantSize DLUX3

    - #### DLUX4

          public static final ConstantSize DLUX4

    - #### DLUX5

          public static final ConstantSize DLUX5

    - #### DLUX6

          public static final ConstantSize DLUX6

    - #### DLUX7

          public static final ConstantSize DLUX7

    - #### DLUX8

          public static final ConstantSize DLUX8

    - #### DLUX9

          public static final ConstantSize DLUX9

    - #### DLUX11

          public static final ConstantSize DLUX11

    - #### DLUX14

          public static final ConstantSize DLUX14

    - #### DLUX21

          public static final ConstantSize DLUX21

      21 horizontal dialog units.
      Since:
        1.2

    - #### DLUY1

          public static final ConstantSize DLUY1

    - #### DLUY2

          public static final ConstantSize DLUY2

    - #### DLUY3

          public static final ConstantSize DLUY3

    - #### DLUY4

          public static final ConstantSize DLUY4

    - #### DLUY5

          public static final ConstantSize DLUY5

    - #### DLUY6

          public static final ConstantSize DLUY6

    - #### DLUY7

          public static final ConstantSize DLUY7

    - #### DLUY8

          public static final ConstantSize DLUY8

    - #### DLUY9

          public static final ConstantSize DLUY9

    - #### DLUY11

          public static final ConstantSize DLUY11

    - #### DLUY14

          public static final ConstantSize DLUY14

    - #### DLUY21

          public static final ConstantSize DLUY21

      21 vertical dialog units.
      Since:
        1.2

    - #### MINIMUM

          public static final com.jgoodies.forms.layout.Sizes.ComponentSize MINIMUM

      Use the maximum of all component minimum sizes as column or row size.

    - #### PREFERRED

          public static final com.jgoodies.forms.layout.Sizes.ComponentSize PREFERRED

      Use the maximum of all component preferred sizes as column or row size.

    - #### DEFAULT

          public static final com.jgoodies.forms.layout.Sizes.ComponentSize DEFAULT

      Use the maximum of all component sizes as column or row size; measures preferred sizes when asked for the preferred size and minimum sizes when asked for the minimum size.

  - ### Method Detail

    - #### constant

          public static ConstantSize constant(String encodedValueAndUnit,
                              boolean horizontal)

      Creates and returns an instance of `ConstantSize` from the given encoded size and unit description.
      Parameters:
        `encodedValueAndUnit` - value and unit in string representation
        `horizontal` - true for horizontal, false for vertical
      Returns:
        a `ConstantSize` for the given value and unit

    - #### dluX

          public static ConstantSize dluX(int value)

      Creates and returns a ConstantSize for the specified value in horizontal dialog units.
      Parameters:
        `value` - size value in horizontal dialog units
      Returns:
        the associated `ConstantSize`

    - #### dluY

          public static ConstantSize dluY(int value)

      Creates and returns a ConstantSize for the specified value in vertical dialog units.
      Parameters:
        `value` - size value in vertical dialog units
      Returns:
        the associated `ConstantSize`

    - #### pixel

          public static ConstantSize pixel(int value)

      Creates and returns a ConstantSize for the specified pixel value.
      Parameters:
        `value` - value in pixel
      Returns:
        the associated `ConstantSize`

    - #### bounded

          public static Size bounded(Size basis,
                     Size lowerBound,
                     Size upperBound)

      Creates and returns a BoundedSize for the given basis using the specified lower and upper bounds.
      Parameters:
        `basis` - the base size
        `lowerBound` - the lower bound size
        `upperBound` - the upper bound size
      Returns:
        a `BoundedSize` for the given basis and bounds
      Throws:
        `NullPointerException` - if `basis` is `null`, or if both `lowerBound` and `upperBound` are `null`.

    - #### inchAsPixel

          public static int inchAsPixel(double in,
                        Component component)

      Converts Inches and returns pixels using the specified resolution.
      Parameters:
        `in` - the Inches
        `component` - the component that provides the graphics object
      Returns:
        the given Inches as pixels

    - #### millimeterAsPixel

          public static int millimeterAsPixel(double mm,
                              Component component)

      Converts Millimeters and returns pixels using the resolution of the given component's graphics object.
      Parameters:
        `mm` - Millimeters
        `component` - the component that provides the graphics object
      Returns:
        the given Millimeters as pixels

    - #### centimeterAsPixel

          public static int centimeterAsPixel(double cm,
                              Component component)

      Converts Centimeters and returns pixels using the resolution of the given component's graphics object.
      Parameters:
        `cm` - Centimeters
        `component` - the component that provides the graphics object
      Returns:
        the given Centimeters as pixels

    - #### pointAsPixel

          public static int pointAsPixel(int pt,
                         Component component)

      Converts DTP Points and returns pixels using the resolution of the given component's graphics object.
      Parameters:
        `pt` - DTP Points
        `component` - the component that provides the graphics object
      Returns:
        the given Points as pixels

    - #### dialogUnitXAsPixel

          public static int dialogUnitXAsPixel(int dluX,
                               Component component)

      Converts horizontal dialog units and returns pixels. Honors the resolution, dialog font size, platform, and l&f.
      Parameters:
        `dluX` - the horizontal dialog units
        `component` - the component that provides the graphics object
      Returns:
        the given horizontal dialog units as pixels

    - #### dialogUnitYAsPixel

          public static int dialogUnitYAsPixel(int dluY,
                               Component component)

      Converts vertical dialog units and returns pixels. Honors the resolution, dialog font size, platform, and l&f.
      Parameters:
        `dluY` - the vertical dialog units
        `component` - the component that provides the graphics object
      Returns:
        the given vertical dialog units as pixels

    - #### getUnitConverter

          public static UnitConverter getUnitConverter()

      Returns the current `UnitConverter`. If it has not been initialized before it will get an instance of `DefaultUnitConverter`.
      Returns:
        the current `UnitConverter`

    - #### setUnitConverter

          public static void setUnitConverter(UnitConverter newUnitConverter)

      Sets a new UnitConverter that will be used to convert font-dependent sizes to pixel sizes.
      Parameters:
        `newUnitConverter` - the unit converter to be set

    - #### getDefaultUnit

          public static ConstantSize.Unit getDefaultUnit()

      Returns the Unit that is used if an encoded ConstantSize contains no unit string.
      Returns:
        the Unit if no unit string is provided
      Since:
        1.2

    - #### setDefaultUnit

          public static void setDefaultUnit(ConstantSize.Unit unit)

      Sets the Unit that shall be used if an encoded ConstantSize provides no unit string.
      Parameters:
        `unit` - the new default Unit, `null` for dialog units
      Throws:
        `IllegalArgumentException` - if `unit` is `ConstantSize.DLUX` or `ConstantSize.DLUY`.
      Since:
        1.2

Copyright © 2002-2015 JGoodies Software GmbH. All Rights Reserved.